-- Name: OpenInvasionChests
-- Author: OffensiveExile
-- Note: Credits to Need Primal Spirits by Nasapunk88 as a reference and hope s/he doesn't mind. This is my first addon.


OpenInvasionChests = {};
OpenInvasionChestsData = OpenInvasionChestsData or {["toggle"] = false, ["bagspace"] = 5, ["availableslots"] = 0, ["level"] = 100, ["currentlevel"] = 0}

function OpenInvasionChests.OnEvent(self,event,...)
	if event == "PLAYER_LOGIN" then
		OpenInvasionChestsData.currentlevel = UnitLevel("player");
		print("|cffADFF2FOIC|r: Type |cffffff78/oic|r or |cffffff78/openinvasionchests|r for help!")
	end
	if event == "PLAYER_LEVEL_UP" then
		OpenInvasionChestsData.currentlevel = select(1,...);
	end
	if OpenInvasionChestsData and OpenInvasionChestsData.toggle and event == "BAG_UPDATE" then
		OpenInvasionChestsData.availableslots = 0;
		for i = 1, 5 do
			OpenInvasionChestsData.availableslots = OpenInvasionChestsData.availableslots + GetContainerNumFreeSlots(i-1);
		end
		if (OpenInvasionChestsData.bagspace < OpenInvasionChestsData.availableslots) and (OpenInvasionChestsData.currentlevel >= OpenInvasionChestsData.level) then
			UseItemByName(139048);
			if (OpenInvasionChestsData.bagspace < OpenInvasionChestsData.availableslots) then
				UseItemByName(139049);
			end
		end
	end
end

local function ChatCommands(msg)
	msg = msg:lower() or "";
	if (msg == "toggle") then
		if OpenInvasionChestsData.toggle then
			OpenInvasionChestsData.toggle = false
			print("|cffADFF2FOIC|r: Disabled!")
		else
			OpenInvasionChestsData.toggle = true
			print("|cffADFF2FOIC|r: Enabled!")
		end
	elseif msg:find("bagspace ") then
		local nmsg = string.gsub(msg, "bagspace ", "")
		OpenInvasionChestsData.bagspace = tonumber(nmsg)
		print("|cffADFF2FOIC|r: Changed free bag slots to " .. nmsg)
	elseif msg:find("level ") then
		local nmsg = string.gsub(msg, "level ", "")
		OpenInvasionChestsData.currentlevel = UnitLevel("player");
		OpenInvasionChestsData.level = tonumber(nmsg)
		print("|cffADFF2FOIC|r: Changed minimum level to " .. nmsg)
	else
		print("|cffADFF2FOIC|r: |cffffff78 toggle|r (enables or disables the addon)")
		print("|cffADFF2FOIC|r: |cffffff78 bagspace x|r (x = minimum bag space)")
		print("|cffADFF2FOIC|r: |cffffff78 level x|r (x = minimum level)")
	end
end


SlashCmdList.OpenInvasionChests = function(msg) ChatCommands(msg) end;
SLASH_OpenInvasionChests1 = "/oic";
SLASH_OpenInvasionChests2 = "/openinvasionchests";

OpenInvasionChests.frame = CreateFrame("Frame");
OpenInvasionChests.frame:RegisterEvent("PLAYER_LOGIN");
OpenInvasionChests.frame:RegisterEvent("PLAYER_LEVEL_UP");
OpenInvasionChests.frame:RegisterEvent("BAG_UPDATE");
OpenInvasionChests.frame:SetScript("OnEvent", OpenInvasionChests.OnEvent);